const path = require('path');

const webpack = require('webpack');
const webpackMerge = require('webpack-merge');
const singleSpaDefaults = require('webpack-config-single-spa-react');
const { UnusedFilesWebpackPlugin } = require('unused-files-webpack-plugin');
const dotenv = require('dotenv');

dotenv.config();

module.exports = (webpackConfigEnv) => {
  const defaultConfig = singleSpaDefaults({
    orgName: '{{orgName}}',
    projectName: '{{projectName}}',
    webpackConfigEnv,
  });

  defaultConfig.plugins.forEach((plugin) => {
    if (plugin instanceof UnusedFilesWebpackPlugin) {
      plugin.options.globOptions.ignore.push(
      {{#each ignores}}
        {{{this}}},
      {{/each}}
      );
    }
  });

  return webpackMerge.smart(defaultConfig, {
    externals: [
    {{#each externals}}
      {{{this}}},
    {{/each}}
    ],
    module: {
      rules: [
        {
          test: /\.(png|jpe?g|gif)$/i,
          use: [
            {
              loader: 'file-loader',
            },
          ],
        },
      ],
    },
    plugins: [
      new webpack.DefinePlugin({
        'process.env': Object.keys(process.env)
          .filter((key) => key.startsWith('REACT_APP'))
          .reduce(
            (prev, curr) => ({ ...prev, [curr]: `"${process.env[curr]}"` }),
            {},
          ),
      }),
    ],
    resolve: {
      alias: {
      {{#each alias}}
        {{{this}}},
      {{/each}}
      },
    },
  });
};
